"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createNumberAttr(value) {
    return { value: value, type: 'number' };
}
exports.createNumberAttr = createNumberAttr;
function createNumberAttrFromIndex(inputIndex) {
    return { inputIndexStart: inputIndex, type: 'number' };
}
exports.createNumberAttrFromIndex = createNumberAttrFromIndex;
function createStrAttr(str) {
    return { value: str, type: 'string' };
}
exports.createStrAttr = createStrAttr;
function createStrArrayAttr(strs) {
    return { value: strs, type: 'string[]' };
}
exports.createStrArrayAttr = createStrArrayAttr;
function createBoolAttr(value) {
    return { value: value, type: 'bool' };
}
exports.createBoolAttr = createBoolAttr;
function createTensorShapeAttr(value) {
    return { value: value, type: 'shape' };
}
exports.createTensorShapeAttr = createTensorShapeAttr;
function createNumericArrayAttr(value) {
    return { value: value, type: 'number[]' };
}
exports.createNumericArrayAttr = createNumericArrayAttr;
function createNumericArrayAttrFromIndex(inputIndex) {
    return { inputIndexStart: inputIndex, type: 'number[]' };
}
exports.createNumericArrayAttrFromIndex = createNumericArrayAttrFromIndex;
function createTensorAttr(index) {
    return { inputIndexStart: index, type: 'tensor' };
}
exports.createTensorAttr = createTensorAttr;
function createTensorsAttr(index, paramLength) {
    return { inputIndexStart: index, inputIndexEnd: paramLength, type: 'tensors' };
}
exports.createTensorsAttr = createTensorsAttr;
function createDtypeAttr(dtype) {
    return { value: dtype, type: 'dtype' };
}
exports.createDtypeAttr = createDtypeAttr;
function validateParam(node, opMappers, tfOpName) {
    var opMapper = tfOpName != null ?
        opMappers.find(function (mapper) { return mapper.tfOpName === tfOpName; }) :
        opMappers.find(function (mapper) { return mapper.tfOpName === node.op; });
    return Object.keys(node.inputParams).every(function (key) {
        var value = node.inputParams[key];
        var def = opMapper.inputs.find(function (param) { return param.name === key; });
        return def && def.type === value.type &&
            def.start === value.inputIndexStart && def.end === value.inputIndexEnd;
    }) &&
        Object.keys(node.attrParams).every(function (key) {
            var value = node.attrParams[key];
            var def = opMapper.attrs.find(function (param) { return param.name === key; });
            return def && def.type === value.type;
        });
}
exports.validateParam = validateParam;
//# sourceMappingURL=test_helper.js.map